Index: /trunk/fmgVen/src/com/fmguler/ven/QueryMapper.java
===================================================================
--- /trunk/fmgVen/src/com/fmguler/ven/QueryMapper.java	(revision 30)
+++ /trunk/fmgVen/src/com/fmguler/ven/QueryMapper.java	(revision 30)
@@ -0,0 +1,193 @@
+/*
+ *  fmgVen - A Convention over Configuration Java ORM Tool
+ *  Copyright 2010 Fatih Mehmet Güler
+ * 
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ * 
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ *  under the License.
+ */
+package com.fmguler.ven;
+
+import com.fmguler.ven.util.Convert;
+import com.fmguler.ven.util.VenList;
+import java.beans.PropertyDescriptor;
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import javax.sql.DataSource;
+import org.springframework.beans.BeanWrapper;
+import org.springframework.beans.BeanWrapperImpl;
+import org.springframework.jdbc.core.RowCallbackHandler;
+import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
+
+/**
+ * Maps the result of the query generated in the form of 'Convention over Configuration' to the specified object.
+ * @author Fatih Mehmet Güler
+ */
+public class QueryMapper {
+    private NamedParameterJdbcTemplate template;
+    private Set domainPackages;
+    private Set dbClasses;
+    private boolean debug = true;
+
+    public QueryMapper() {
+        domainPackages = new HashSet();
+        dbClasses = new HashSet();
+        //the predefined database classes;
+        this.dbClasses.add(Integer.class);
+        this.dbClasses.add(String.class);
+        this.dbClasses.add(Date.class);
+        this.dbClasses.add(Double.class);
+        this.dbClasses.add(Boolean.class);
+    }
+
+    /**
+     * Executes the specified query setting the specified parameters,
+     * and maps the results to the instances of the specified objectClass.
+     * @param query select SQL query in the conventional format
+     * @param parameters named query parameter values
+     * @param objectClass the type of the object to be mapped
+     * @return the list of mapped objects
+     */
+    public List list(String query, Map parameters, final Class objectClass) {
+        long t1 = System.currentTimeMillis();
+        final List results = new LinkedList();
+        final String tableName = Convert.toDB(Convert.toSimpleName(objectClass.getName()));
+        final Set columns = new HashSet();
+
+        template.query(query, parameters, new RowCallbackHandler() {
+            public void processRow(ResultSet rs) throws SQLException {
+                enumerateColumns(columns, rs);
+                mapRecursively(rs, columns, tableName, objectClass, results);
+            }
+        });
+
+        System.out.println("Ven - list time = " + (System.currentTimeMillis() - t1));
+        return results;
+    }
+
+    //--------------------------------------------------------------------------
+    //PRIVATE METHODS
+    //recursively map the resultSet to the object and add to the list
+    protected void mapRecursively(ResultSet rs, Set columns, String tableName, Class objectClass, List parentList) {
+        try {
+            if (!columns.contains(tableName + "_id")) return; //this object does not exist in the columns
+            Object id = rs.getObject(tableName + "_id");
+            if (id == null) return; //this object exists in the columns but null, probably because of left join
+
+            //create bean wrapper for the object class
+            BeanWrapper wr = new BeanWrapperImpl(objectClass); //already caches class introspection (CachedIntrospectionResults.forClass())
+            wr.setPropertyValue("id", id); //set the id property
+            Object object = wr.getWrappedInstance();
+            boolean map = true;
+
+            //check if this object exists in the parent list (since SQL joins are cartesian products, do not create new object if this row is just the same as previous)
+            for (Iterator it = parentList.iterator(); it.hasNext();) {
+                Object objectInList = (Object)it.next();
+                if (objectIdEquals(objectInList, id)) {
+                    wr.setWrappedInstance(objectInList); //already exists in the list, use that instance
+                    map = false; // and do not map again
+                    break;
+                }
+            }
+            if (map) parentList.add(object); //could not find in the parent list, add the new object
+
+            PropertyDescriptor[] pdArr = wr.getPropertyDescriptors();
+            for (int i = 0; i < pdArr.length; i++) {
+                PropertyDescriptor pd = pdArr[i];
+                Class fieldClass = pd.getPropertyType(); //field class
+                String fieldName = Convert.toDB(pd.getName()); //field name
+                Object fieldValue = wr.getPropertyValue(pd.getName());
+                String columnName = tableName + "_" + fieldName;
+
+                //database class (primitive property)
+                if (map && dbClasses.contains(fieldClass)) {
+                    if (columns.contains(columnName)) {
+                        if (debug) System.out.println(">>field is found: " + columnName);
+                        wr.setPropertyValue(pd.getName(), rs.getObject(columnName));
+                    } else {
+                        if (debug) System.out.println("--field not found: " + columnName);
+                    }
+                }
+
+                //many to one association (object property)
+                if (map && fieldClass.getPackage() != null && domainPackages.contains(fieldClass.getPackage().getName())) {
+                    if (columns.contains(columnName + "_id")) {
+                        if (debug) System.out.println(">>object is found " + columnName);
+                        List list = new ArrayList(1); //we know there will be single result
+                        mapRecursively(rs, columns, columnName, fieldClass, list);
+                        if (list.size() > 0) wr.setPropertyValue(pd.getName(), list.get(0));
+                    } else {
+                        if (debug) System.out.println("--object not found: " + columnName);
+                    }
+                }
+
+                //one to many association (list property)
+                if (fieldValue instanceof List) { //Note: here recurring row's list property is mapped and add to parent's list
+                    if (columns.contains(columnName + "_id")) {
+                        Class elementClass = VenList.findElementClass((List)fieldValue);
+                        if (debug) System.out.println(">>list is found " + columnName);
+                        mapRecursively(rs, columns, columnName, elementClass, (List)fieldValue);
+                    } else {
+                        if (debug) System.out.println("--list not found: " + columnName);
+                    }
+                }
+            }
+        } catch (Exception ex) {
+            if (debug) {
+                System.out.println("Ven - error while mapping row; ");
+                ex.printStackTrace();
+            }
+        }
+    }
+
+    //enumerate columns from the resultset
+    private void enumerateColumns(Set columns, ResultSet rs) throws SQLException {
+        if (!columns.isEmpty()) return;
+        for (int i = 1; i < rs.getMetaData().getColumnCount() + 1; i++) {
+            columns.add(rs.getMetaData().getColumnName(i));
+        }
+    }
+
+    //check if the specified objects are the same entity (according to id fields)
+    private boolean objectIdEquals(Object object, Object id) {
+        //return obj1.equals(obj2); //objects need to implement equals()
+        //TODO: more efficient (invoke getId method)
+        BeanWrapper wr = new BeanWrapperImpl(object);
+        return id.equals(wr.getPropertyValue("id"));
+    }
+
+    //--------------------------------------------------------------------------
+    //SETTERS
+    /**
+     * @param dataSource used for accessing database
+     */
+    public void setDataSource(DataSource dataSource) {
+        if (dataSource == null) throw new RuntimeException("fmgVen - DataSource cannot be null");
+        this.template = new NamedParameterJdbcTemplate(dataSource);
+    }
+
+    /**
+     * Add the domain packages that will be considered persistent
+     * @param domainPackage the domain package
+     */
+    public void addDomainPackage(String domainPackage) {
+        domainPackages.add(domainPackage);
+    }
+}
Index: /trunk/fmgVen/src/com/fmguler/ven/Ven.java
===================================================================
--- /trunk/fmgVen/src/com/fmguler/ven/Ven.java	(revision 30)
+++ /trunk/fmgVen/src/com/fmguler/ven/Ven.java	(revision 30)
@@ -0,0 +1,198 @@
+/*
+ *  fmgVen - A Convention over Configuration Java ORM Tool
+ *  Copyright 2010 Fatih Mehmet Güler
+ * 
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ * 
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ *  under the License.
+ */
+package com.fmguler.ven;
+
+import com.fmguler.ven.util.Convert;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import javax.sql.DataSource;
+import org.springframework.beans.BeanWrapper;
+import org.springframework.beans.BeanWrapperImpl;
+import org.springframework.jdbc.core.namedparam.BeanPropertySqlParameterSource;
+import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
+import org.springframework.jdbc.core.namedparam.SqlParameterSource;
+
+/**
+ * The main class for data access
+ * @author Fatih Mehmet Güler
+ */
+public class Ven {
+    private NamedParameterJdbcTemplate template;
+    private QueryGenerator generator;
+    private QueryMapper mapper;
+    private boolean debug = true;
+
+    public Ven() {
+        generator = new QueryGenerator();
+        mapper = new QueryMapper();
+    }
+
+    public int count() {
+        return 0;
+    }
+
+    /**
+     * Get the object with the specified id, of the specified objectClass type.
+     * <p>
+     * By default none of the associations will be retrieved.
+     * To include the object associations (retrieve the object graph) joins should be specified, e.g.
+     * <code>SomeObject.anotherObject</code>
+     * 
+     * @param id the id of the object to be retrieved
+     * @param objectClass the class of the object to be retrieved
+     * @param joins the set of object graphs to be included with the object
+     * @return the retrieved object including specified associations
+     */
+    public Object get(int id, Class objectClass, Set joins) {
+        String query = generator.generateSelectQuery(objectClass, joins);
+        query += " where 1=1 and " + Convert.toDB(Convert.toSimpleName(objectClass.getName())) + ".id = :___id ";
+
+        Map paramMap = new HashMap();
+        paramMap.put("___id", new Integer(id));
+        if (debug) System.out.println("Ven - SQL: " + query);
+
+        List result = mapper.list(query, paramMap, objectClass);
+        if (result.isEmpty()) return null;
+        if (result.size() > 1) System.out.println("Ven - WARNING >> get(id) returns more than one row");
+        return result.get(0);
+    }
+
+    /**
+     * List the objects of the specified objectClass type.
+     * <p>
+     * By default none of the associations will be retrieved.
+     * To include the object associations (retrieve the object graph) joins should be specified, e.g.
+     * <code>SomeObject.anotherObject</code>
+     * 
+     * @param objectClass the class of the objects to be retrieved
+     * @param joins the set of object graphs to be included with objects
+     * @return the list of objects including specified associations
+     */
+    public List list(Class objectClass, Set joins) {
+        String query = generator.generateSelectQuery(objectClass, joins);
+
+        Map paramMap = new HashMap();
+        if (debug) System.out.println("Ven - SQL: " + query);
+
+        List result = mapper.list(query, paramMap, objectClass);
+        return result;
+    }
+
+    /**
+     * List the objects of the specified objectClass type, filtering according to some criteria.
+     * <p>
+     * By default none of the associations will be retrieved.
+     * To include the object associations (retrieve the object graph) joins should be specified, e.g.
+     * <code>SomeObject.anotherObject</code>
+     * 
+     * @param objectClass the class of the objects to be retrieved
+     * @param joins the set of object graphs to be included with objects
+     * @param criteria to filter and order the result according to some criteria
+     * @return the list of objects including the specified associations filtered according to the specified criteria
+     */
+    public List list(Class objectClass, Set joins, Criteria criteria) {
+        String query = generator.generateSelectQuery(objectClass, joins);
+        query += " where 1=1 " + criteria.criteriaStringToSQL() + " and " + criteria.criteriaToSQL();
+
+        if (debug) System.out.println("Ven - SQL: " + query);
+
+        List result = mapper.list(query, criteria.getParameters(), objectClass);
+        return result;
+    }
+
+    /**
+     * Save the object. If it has a non null (or non zero) "id" property it will be updated.
+     * It will be inserted otherwise.
+     * <p>
+     * The object will be saved to a table with the same name as the object,
+     * The fields of object will be mapped to the table fields.
+     * 
+     * @param object the object to be saved
+     */
+    public void save(Object object) {
+        String query = null;
+
+        if (isObjectNew(object)) {
+            //if this is a new object assign a new id first
+            generateId(object);
+            query = generator.generateInsertQuery(object);
+        } else {
+            query = generator.generateUpdateQuery(object);
+        }
+
+        //execute the insert/update query
+        SqlParameterSource parameterSource = new BeanPropertySqlParameterSource(object);
+        template.update(query, parameterSource);
+    }
+
+    /**
+     * Delete the the object with the specified id of the specified objectClass type
+     * @param id the id of the object to be deleted
+     * @param objectClass the class of the object to be deleted
+     */
+    public void delete(int id, Class objectClass) {
+        String query = generator.generateDeleteQuery(objectClass);
+        Map parameterMap = new HashMap();
+        parameterMap.put("id", new Integer(id));
+        template.update(query, parameterMap);
+    }
+
+    //--------------------------------------------------------------------------
+    //PRIVATE METHODS
+    //return true if the object id is zero or null false otherwise
+    private boolean isObjectNew(Object object) throws VenException {
+        BeanWrapper beanWrapper = new BeanWrapperImpl(object);
+        Object objectId = beanWrapper.getPropertyValue("id");
+        if (objectId == null) return true;
+        if (!(objectId instanceof Integer)) throw new VenException(VenException.EC_GENERATOR_OBJECT_ID_TYPE_INVALID);
+        return ((Integer)objectId).intValue() == 0;
+    }
+
+    //set new object id
+    private void generateId(Object object) {
+        Integer newObjectId = new Integer(template.queryForInt(generator.generateSequenceQuery(object), new HashMap()));
+        BeanWrapper beanWrapper = new BeanWrapperImpl(object);
+        beanWrapper.setPropertyValue("id", newObjectId);
+    }
+
+    //--------------------------------------------------------------------------
+    //SETTERS
+    /**
+     * Set the DataSource to be used to access to the database
+     */
+    public void setDataSource(DataSource dataSource) {
+        if (dataSource == null) throw new RuntimeException("fmgVen - DataSource cannot be null");
+        this.template = new NamedParameterJdbcTemplate(dataSource);
+        mapper.setDataSource(dataSource);
+    }
+
+    /**
+     * Add the domain packages that have corresponding database tables.
+     * <p>
+     * The objects in these packages are considered persistable.
+     * @param domainPackage the package of the entity classes.
+     * @return this instance to allow chaining.
+     */
+    public Ven addDomainPackage(String domainPackage) {
+        generator.addDomainPackage(domainPackage);
+        mapper.addDomainPackage(domainPackage);
+        return this;
+    }
+}
Index: /trunk/fmgVen/src/com/fmguler/ven/VenException.java
===================================================================
--- /trunk/fmgVen/src/com/fmguler/ven/VenException.java	(revision 30)
+++ /trunk/fmgVen/src/com/fmguler/ven/VenException.java	(revision 30)
@@ -0,0 +1,74 @@
+/*
+ *  fmgVen - A Convention over Configuration Java ORM Tool
+ *  Copyright 2010 Fatih Mehmet Güler
+ * 
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ * 
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ *  under the License.
+ */
+package com.fmguler.ven;
+
+/**
+ * All kinds of exceptions in Ven operations.
+ * @author Fatih Mehmet Güler
+ */
+public class VenException extends RuntimeException {
+    private String errorCode;
+    private String errorParam;
+    //Error codes
+    //"Invalid object, \"id\" property must be of integer type"
+    public static final String EC_GENERATOR_OBJECT_ID_TYPE_INVALID = "ec-generator-object-id-type-invalid";
+
+    /**
+     * Init VenException with an error code
+     * @param errorCode the error code
+     */
+    public VenException(String errorCode) {
+        this.errorCode = errorCode;
+    }
+
+    /**
+     * Init VenException with an error code and an error parameter
+     * @param errorCode the error code
+     * @param errorParam the error param
+     */
+    public VenException(String errorCode, String errorParam) {
+        this.errorCode = errorCode;
+        this.errorParam = errorParam;
+    }
+
+    /**
+     * Init VenException with an error code, error parameter and the cause of the exception
+     * @param errorCode the error code
+     * @param errorParam the error parameter
+     * @param cause the cause of the exception
+     */
+    public VenException(String errorCode, String errorParam, Throwable cause) {
+        super(cause);
+        this.errorCode = errorCode;
+        this.errorParam = errorParam;
+    }
+
+    /**
+     * @return the error code of the exception
+     */
+    public String getErrorCode() {
+        return errorCode;
+    }
+
+    /**
+     * @return the error parameter of the exception, which can contain details about the error
+     */
+    public String getErrorParam() {
+        return errorParam;
+    }
+}
Index: /trunk/fmgVen/src/com/fmguler/ven/util/Convert.java
===================================================================
--- /trunk/fmgVen/src/com/fmguler/ven/util/Convert.java	(revision 30)
+++ /trunk/fmgVen/src/com/fmguler/ven/util/Convert.java	(revision 30)
@@ -0,0 +1,61 @@
+/*
+ *  fmgVen - A Convention over Configuration Java ORM Tool
+ *  Copyright 2010 Fatih Mehmet Güler
+ * 
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ * 
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ *  under the License.
+ */
+package com.fmguler.ven.util;
+
+import java.util.Locale;
+
+/**
+ * Utility class for conversions from database naming convention to java, and vice versa
+ * @author Fatih Mehmet Güler
+ */
+public class Convert {
+    /**
+     * Convert from java camelCase case to database naming convention
+     * <p>
+     * For example, if the name of the given name is SomeDomainObject
+     * it will be converted to some_domain_object
+     *
+     * @param camelCase the camelCase case name
+     * @return database style name
+     */
+    public static String toDB(String camelCase) {
+        if (camelCase.equals("")) return "";
+        StringBuffer result = new StringBuffer();
+        result.append(camelCase.substring(0, 1).toLowerCase(Locale.ENGLISH));
+        for (int i = 1; i < camelCase.length(); i++) {
+            String sCamel = camelCase.substring(i, i + 1);
+            String sLower = sCamel.toLowerCase(Locale.ENGLISH);
+            if (!sCamel.equals(sLower)) {
+                result.append("_").append(sLower);
+            } else result.append(sCamel);
+        }
+        return result.toString();
+    }
+
+    /**
+     * Convert the full package name to simple name.
+     * For Java 1.4 compatibility of Class.getSimpleName()
+     * @param fullName Class.getName()
+     * @return the part after the last .
+     */
+    public static String toSimpleName(String fullName) {
+        int i = fullName.lastIndexOf(".");
+        if (i < 0) return fullName;
+        return fullName.substring(i + 1);
+    }
+}
Index: /trunk/fmgVen/src/com/fmguler/ven/util/VenList.java
===================================================================
--- /trunk/fmgVen/src/com/fmguler/ven/util/VenList.java	(revision 30)
+++ /trunk/fmgVen/src/com/fmguler/ven/util/VenList.java	(revision 30)
@@ -0,0 +1,88 @@
+/*
+ *  fmgVen - A Convention over Configuration Java ORM Tool
+ *  Copyright 2011 Fatih Mehmet Güler
+ * 
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ * 
+ *       http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ *  under the License.
+ */
+package com.fmguler.ven.util;
+
+import java.util.LinkedList;
+import java.util.List;
+
+/**
+ * A Simple Linked List which informs the type of its elements.
+ * @author Fatih Mehmet Güler
+ */
+public class VenList extends LinkedList {
+    private Class elementClass;
+    private String joinField;
+
+    /**
+     * Creates new instance of VenList
+     */
+    public VenList() {
+    }
+
+    /**
+     * Creates new instance of VenList, specifying the type of elements
+     * @param elementClass the type of elements of this list
+     */
+    public VenList(Class elementClass) {
+        this.elementClass = elementClass;
+    }
+
+    /**
+     * Creates new instance of VenList, specifying the type of elements and the join field
+     * @param elementClass the type of elements of this list
+     * @param joinField the field which refers to the parent object
+     */
+    public VenList(Class elementClass, String joinField) {
+        this.elementClass = elementClass;
+        this.joinField = joinField;
+    }
+
+    /**
+     * Returns the type of the elements in this list.
+     * @return element type
+     */
+    public Class getElementClass() {
+        return elementClass;
+    }
+
+    /**
+     * Returns the field in the element class which refers the parent object
+     * @return element join field
+     */
+    public String getJoinField() {
+        return joinField;
+    }
+
+    /**
+     * Return the class of the elements in the list
+     * @param list the list
+     * @return the element class in the list
+     */
+    public static Class findElementClass(List list) {
+        if (list.size() > 0) {
+            Object elem = list.get(0);
+            return elem.getClass();
+        }
+        if (list instanceof VenList) {
+            return ((VenList)list).getElementClass();
+        } else {
+            //find according to 1.5 generic or some convention (e.g. xyzList -> xyz)
+            return null;
+        }
+    }
+}
Index: /trunk/fmgVen/src/net/fmg/ven/Olcut.java
===================================================================
--- /trunk/fmgVen/src/net/fmg/ven/Olcut.java	(revision 20)
+++ /trunk/fmgVen/src/net/fmg/ven/Olcut.java	(revision 30)
@@ -3,9 +3,8 @@
  *
  * Created on December 20, 2006, 1:45 PM
- * (4.12.06 tarihli SpringDaoDeneme çalýþmasýndan derlenmiþtir)
+ * (4.12.06 tarihli SpringDaoDeneme çalışmasından derlenmiştir)
  *
- * Ven - Ayar Yerine Gelenek veritabaný eriþim nesnesi
+ * Ven - Ayar Yerine Gelenek veritabanı erişim nesnesi
  */
-
 package net.fmg.ven;
 
@@ -18,5 +17,5 @@
 
 /**
- * Ven için ölçütlerin belirlenebileceði sýnýf
+ * Ven için ölçütlerin belirlenebileceği sınıf
  * @author Fatih Mehmet Güler
  */
@@ -25,5 +24,5 @@
     private Map parametreler;
     private Set baglaclar;
-    
+
     /** 
      * Yeni ölçüt
@@ -32,81 +31,80 @@
         this.metin = "";
         this.parametreler = new HashMap();
-        this.baglaclar =  new HashSet();
+        this.baglaclar = new HashSet();
         //{"and", "or", "=", "<>", "<", ">"}
     }
-    
+
     /**
      * YAPILMADI
      */
-    public Olcut ekle(Olcut olcut){        
+    public Olcut ekle(Olcut olcut) {
         return null;
     }
-    
+
     /**
      * YAPILMADI
      */
-    public Olcut ekle(List olcutler){        
+    public Olcut ekle(List olcutler) {
         return null;
     }
-    
+
     /**
      * YAPILMADI
      */
-    public Olcut ve(){
+    public Olcut ve() {
         return null;
     }
-    
+
     /**
-     * koþul ekle
+     * koşul ekle
      */
-    public Olcut ekle(String kosul){
-        this.metin +=" "+kosul;
+    public Olcut ekle(String kosul) {
+        this.metin += " " + kosul;
         return this;
     }
-    
+
     /**
-     * koþullarda kullanýlan parametreleri ekle
+     * koşullarda kullanılan parametreleri ekle
      */
-    public Olcut ekle(String parametre, Object nesne){
-        this.parametreler.put(parametre,nesne);
+    public Olcut ekle(String parametre, Object nesne) {
+        this.parametreler.put(parametre, nesne);
         return this;
     }
-    
+
     /**
-     * koþullarda kullanýlan parametreleri tümden ekle
+     * koşullarda kullanılan parametreleri tümden ekle
      */
-    public Olcut ekle(Map parametreler){
+    public Olcut ekle(Map parametreler) {
         this.parametreler.putAll(parametreler);
         return this;
     }
-    
-    public String olcutleriAl(){
+
+    public String olcutleriAl() {
         //((1=1) and ((1=1) and (musteri_numuneler_numune_sahibi.rapor_tarihi is null) and (musteri.no = 4)))
         //Musteri.numuneler.deneyler.deneyTip.ad like :p1
         String sonuc = "";
-        metin = metin.replace("(","( ");
-        metin = metin.replace(")"," )");
+        metin = metin.replaceAll("\\(", "\\( ");
+        metin = metin.replaceAll("\\)", " \\)");
         String[] parcalar = metin.split(" ");
         for (int i = 0; i < parcalar.length; i++) {
-            if (!parcalar[i].startsWith(":") && parcalar[i].contains(".")){
-                int sonNokta = parcalar[i].lastIndexOf('.');                
+            if (!parcalar[i].startsWith(":") && parcalar[i].indexOf(".") >= 0) {
+                int sonNokta = parcalar[i].lastIndexOf('.');
                 sonuc += " ";
-                int u = parcalar[i].length();                
-                sonuc +=Cevir.vt(parcalar[i].substring(0,sonNokta).replace('.','_'));
-                sonuc +=Cevir.vt(parcalar[i].substring(sonNokta,u));
-            }else{
-                sonuc += " "+parcalar[i];
+                int u = parcalar[i].length();
+                sonuc += Cevir.vt(parcalar[i].substring(0, sonNokta).replace('.', '_'));
+                sonuc += Cevir.vt(parcalar[i].substring(sonNokta, u));
+            } else {
+                sonuc += " " + parcalar[i];
             }
         }
         return sonuc;
     }
-    
-    public Map parametreler(){
+
+    public Map parametreler() {
         return this.parametreler;
     }
 
     public String toString() {
-        return olcutleriAl()+" "+this.parametreler;
+        return olcutleriAl() + " " + this.parametreler;
     }
-    
 }
